#include "Statistics.hh"

#include <unistd.h>
#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>

#include <string> 
   using namespace std;


/*!

This main program demonstrates how to use the Statistics class in an
application

 */

int main(void)
{

  int NumberOfSamples;

  cout << "Enter number of samples: ";
  cin >> NumberOfSamples;
  cout << NumberOfSamples << endl;

  double * SampleArray;

  SampleArray = new double[NumberOfSamples];

  cout << "Enter the samples separated by spaces" << endl;

  for(int ii=0; ii < NumberOfSamples; ii++)
    cin >> SampleArray[ii];

  cout << "The samples are:" << endl;

  for(int ii=0; ii < NumberOfSamples; ii++)
     cout << SampleArray[ii] << " ";
 
  cout << endl;


  /* Construct an instance of the Statistics class which is called
     oStatistics. We call oStatistics a Statistics object. 

     You can think of Statistics as a user-defined type and oStatistics
     as a variable of that type. 

     To construct oStatistics we call the Statistics constructor
     which initializes all the data of the object oStatitics.
  */



  Statistics oStatistics(NumberOfSamples,SampleArray);

  /* To access the member function GetMinimim() of the object oStatistics we
     use the syntax  oStatistics.GetMinimum(). 
     In general we use MyClass.MyMethod().
  */

  cout << "Minimum = " << oStatistics.GetMinimum() << endl;
  cout << "Maximum = " << oStatistics.GetMaximum() << endl;
  cout << "Median = " << oStatistics.GetMedian() << endl;
  cout << "Mean = " << oStatistics.GetMean() << endl;
  cout << "Variance = " << oStatistics.GetVariance() << endl;

  cout << "THE END" << endl;


  return 1;

} // ## end main

// ###################################################

/********

// Sometimes people work with pointers to classes instead of working with the
// classes directly. Here's how the syntax works:

  Statistics * oStatisticsPtr; // Pointer to a Statistics object 

  // oStatisticsPtr can point to the memory location of a Statistics object

  // Dynamically allocate memory for a  Statistics object using new
  // and let oStatisticsPtr point to the memory location of that object
 
   oStatisticsPtr =  new Statistics(NumberOfSamples,SampleArray);

  // Remember that oStatisticsPtr is a pointer to a Statistics object
  // It just stores the address of the Statistics object
  // The actual Statistics object is called *oStatisticsPtr

  // To access a member function of the object  *oStatisticsPtr use 
  // -> instead of ., as in oStatisticsPtr->MyFunction()

  cout << "Maximum = " << oStatisticsPtr->GetMaximum() << endl;

  // Alternatively, since the actual Statistics object 
  // is called *oStatisticsPtr you can access a member function 
  // you can also use:  (*oStatisticsPtr).MyFunction();

  cout << "Maximum = " << (*oStatisticsPtr).GetMaximum() << endl;

***********/



